#include <minigui.ch>


function main
private backcolor := {0,0,0}
private akalai := {}

define window k at 0,0 width 650 height 530 title "Kaleidoscope" main icon "kalai" nosize on init drawkalai()
   define timer timer1 interval 5000 action drawkalai()

   define label triangleslabel
      row 10
      col 510
      value "Triangles"
      width 80
   end label
   define spinner triangles
      row 10
      col 590
      width 50
      rangemin 1
      rangemax 999
      value 30
   end spinner
   define button backcolor
      row 40
      col 510
      width 130
      caption "Background Colour"
      action  setbackcolor()
   end button
   define checkbox show1
      row 70
      col 510
      caption "Slideshow (5 Sec)"
      width 130
      onchange show1changed()
   end checkbox
   define button but1
      row 100
      col 510
      width 60
      caption "Show"
      action drawkalai()
   end button
   define button save
      row 100
      col 580
      width 60
      caption "Save"
      action savewindow1()
   end button
   define button showstereo
      row 130
      col 510
      width 130
      caption "Show Stereo"
      action showstereowindow()
   end button
   
   
   DEFINE hyperlink email
      row 400
      col 510
      value "E-Mail me"
      transparent .t.
      width 130
      handcursor .t.
      address "srgiri@dataone.in"
      fontbold .t.
   END hyperlink
   DEFINE hyperlink email1
      row 420
      col 510
      value "Algorithm of Cliff"
      transparent .t.
      width 130
      handcursor .t.
      address "http://sprott.physics.wisc.edu/pickover/ekscop.html"
      fontbold .t.
   END hyperlink
end window

k.timer1.enabled := .f.
k.center
activate window k

return nil

function drawkalai
local aPoints := {}
local x := 250  // xcenter
local y := 250  // ycenter
local x1,x2,x3,y1,y2,y3,t
local stereobase := 30
local sdiff := 0.0

asize(akalai,0)
erase window k
if k.triangles.value < 1
   return nil
endif


drawrect("k",0,0,x*2,y*2,backcolor,,backcolor)

FOR i = 1 to k.triangles.value
    x1 = random(x);   y1 = random(y)
    x2 = random(x);   y2 = random(y)
    x3 = random(x);   y3 = random(y)
    r := random(255)
    g := random(255)
    b := random(255)
    /* Confine initial pattern to lower right quadrant */
    if ( x1 > y1 ) 
       t := x1
       x1 := y1
       y1 := t
    endif
    if ( x2 > y2 ) 
       t := x2
       x2 := y2
       y2 := t
    endif
    if ( x3 > y3 ) 
       t := x3
       x3 := y3
       y3 := t
    endif
    aPoints := {{x+x1,y+y1},{x+x2,y+y2},{x+x3,y+y3}}
    drawpolygon("k",aPoints,{r,g,b},,{r,g,b})
    aadd(akalai,{aclone(apoints),{r,g,b}})

        
    aPoints := {{y+y1,x+x1},{y+y2,x+x2},{y+y3,x+x3}}
    drawpolygon("k",aPoints,{r,g,b},,{r,g,b})
    aadd(akalai,{aclone(apoints),{r,g,b}})

        
    aPoints := {{x-x1,y+y1},{x-x2,y+y2},{x-x3,y+y3}}
    drawpolygon("k",aPoints,{r,g,b},,{r,g,b})
    aadd(akalai,{aclone(apoints),{r,g,b}})

    aPoints := {{x+x1,y-y1},{x+x2,y-y2},{x+x3,y-y3}}
    drawpolygon("k",aPoints,{r,g,b},,{r,g,b})
    aadd(akalai,{aclone(apoints),{r,g,b}})

    
    aPoints := {{x-x1,y-y1},{x-x2,y-y2},{x-x3,y-y3}}
    drawpolygon("k",aPoints,{r,g,b},,{r,g,b})
    aadd(akalai,{aclone(apoints),{r,g,b}})

    aPoints := {{y+y1,x-x1},{y+y2,x-x2},{y+y3,x-x3}}
    drawpolygon("k",aPoints,{r,g,b},,{r,g,b})
    aadd(akalai,{aclone(apoints),{r,g,b}})

    aPoints := {{y-y1,x+x1},{y-y2,x+x2},{y-y3,x+x3}}
    drawpolygon("k",aPoints,{r,g,b},,{r,g,b})
    aadd(akalai,{aclone(apoints),{r,g,b}})

      
    aPoints := {{y-y1,x-x1},{y-y2,x-x2},{y-y3,x-x3}}
    drawpolygon("k",aPoints,{r,g,b},,{r,g,b})
    aadd(akalai,{aclone(apoints),{r,g,b}})

    
next i

return nil

function savewindow1
local filename := ""

if k.show1.value
   k.timer1.enabled := .f.
endif

filename := PutFile ( {{"Bitmap Files (*.bmp)","*.bmp"}} , "Save to bitmap file" ,  , .f. ) 
if len(alltrim(filename)) == 0
   return nil
endif

if at(".bmp",lower(filename)) > 0
   if .not. right(lower(filename),4) == ".bmp"
      filename := filename + ".bmp"
   endif
else
   filename := filename + ".bmp"
endif

if file(filename)
   if .not. msgyesno("Are you sure to overwrite?","Save to bitmap")
      return nil
   endif
endif
savewindow("k",filename,0,0,500,500)
if k.show1.value
   k.timer1.enabled := .t.
endif

return nil

function setbackcolor
backcolor := getcolor(backcolor)
return nil

function show1changed
if .not. iscontroldefined(timer1,k)
   return nil
endif
if k.show1.value
   k.timer1.enabled := .t.
else   
   k.timer1.enabled := .f.
endif
return nil


function showstereowindow

if .not. iswindowdefined(s)
   define window s at 0,0 width 1100 height 580 modal nosize backcolor {0,0,0} on init drawstereowindow()
   define button save1
      row 520
      col 10
      width 50
      caption "Save"
      action savestereowindow1()
   end button

   end window
   s.center
   s.activate
else
   drawstereowindow()   
endif   

return nil

function drawstereowindow
local stereobase := 30
local sdiff := 0.0

if len(akalai) == 0
   return nil
endif
sdiff := stereobase/k.triangles.value


erase window s
drawrect("s",0,0,500,1030,backcolor,,backcolor)

for i := 1 to len(akalai)
   drawstereopolygon("s",aclone(akalai[i,1]),aclone(akalai[i,2]),250,stereobase,sdiff*i/8)
next i

return nil

function drawstereopolygon(winname,apoints1,color1,y,stereobase,sdiff)
local alpoints := aclone(apoints1)
local arpoints := aclone(apoints1)

alpoints[1,2] := alpoints[1,2] + stereobase - sdiff
alpoints[2,2] := alpoints[2,2] + stereobase - sdiff
alpoints[3,2] := alpoints[3,2] + stereobase - sdiff
arpoints[1,2] := arpoints[1,2]+ (2*y) + stereobase
arpoints[2,2] := arpoints[2,2]+ (2*y) + stereobase
arpoints[3,2] := arpoints[3,2]+ (2*y) + stereobase

drawpolygon(winname,alPoints,color1,,color1)
drawpolygon(winname,arPoints,color1,,color1)
return nil


function savestereowindow1
local filename := ""

if k.show1.value
   k.timer1.enabled := .f.
endif

filename := PutFile ( {{"Bitmap Files (*.bmp)","*.bmp"}} , "Save to bitmap file" ,  , .f. ) 
if len(alltrim(filename)) == 0
   return nil
endif

if at(".bmp",lower(filename)) > 0
   if .not. right(lower(filename),4) == ".bmp"
      filename := filename + ".bmp"
   endif
else
   filename := filename + ".bmp"
endif

if file(filename)
   if .not. msgyesno("Are you sure to overwrite?","Save to bitmap")
      return nil
   endif
endif
savewindow("s",filename,0,0,1030,500)
if k.show1.value
   k.timer1.enabled := .t.
endif

return nil
